﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Data;
using Infragistics.UltraChart.Core.Primitives;

namespace UltraChartGanttChartExcludeRow
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


            // This could be data from your database
            DataTable dt = new DataTable();
            dt.Columns.Add("StartDate", typeof(DateTime));
            dt.Columns.Add("EndDate", typeof(DateTime));
            dt.Columns.Add("Owner", typeof(string));
            dt.Columns.Add("Label", typeof(string));

            dt.Rows.Add(DateTime.Today, DateTime.Today.AddDays(1), "Owner 1", "Test 1");
            dt.Rows.Add(DateTime.Today.AddDays(2), DateTime.Today.AddDays(4), "Owner 2", "Test 2");
            dt.Rows.Add(DateTime.Today.AddDays(1), DateTime.Today.AddDays(4), "Owner 3", "Test 3");
            dt.Rows.Add(DateTime.Today.AddDays(3), DateTime.Today.AddDays(6), "Owner 4", "Test 4");



            ultraChart1.GanttChart.Columns.StartTimeColumnIndex = 0;
            ultraChart1.GanttChart.Columns.EndTimeColumnIndex = 1;
            ultraChart1.GanttChart.Columns.OwnerColumnIndex = 2;
            ultraChart1.GanttChart.Columns.ItemLabelsColumnIndex = 3;

            
            ultraGrid1.DataSource = dt;
            ultraChart1.DataSource = dt;
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            List<Primitive> listPr = new List<Primitive>();
            foreach (Primitive pr in e.SceneGraph)
            {
                if (pr.GetType() == typeof(Box) && pr.Column != -1 && pr.Row != -1)
                {
                    int k = ((Box)pr).rect.Width;
                    DateTime[] dt = ((Box)pr).Value as DateTime[];
                    if (dt != null && dt[0] == dt[1])
                    {
                        Box mm = new Box(new Rectangle(((Box)pr).rect.X - (((Box)pr).rect.Height / 2), ((Box)pr).rect.Y, ((Box)pr).rect.Height, ((Box)pr).rect.Height));
                        mm.PE.Fill = Color.Red;
                        mm.RotationAngle = 45;
                        listPr.Add(mm);
                    }
                }
            }
            foreach (Primitive item in listPr) e.SceneGraph.Add(item);
        }
    }
}
